From 5fc39962e4fea968a62dcdf402769f42b3a4ec86 Mon Sep 17 00:00:00 2001
From: Thomas NOEL <tnoel@entrouvert.com>
Date: Fri, 11 Jan 2019 17:21:46 +0100
Subject: [PATCH] vincennes: split header top, add a specific logo linked to
 city website (#29683)

---
 static/vincennes-2018/_custom.scss            |  21 ++++++++++--------
 .../vincennes-2018/img/logo_rouge_et_bleu.png | Bin 20948 -> 4629 bytes
 templates/variants/vincennes-2018/theme.html  |   5 +++++
 3 files changed, 17 insertions(+), 9 deletions(-)
 create mode 100644 templates/variants/vincennes-2018/theme.html

diff --git a/static/vincennes-2018/_custom.scss b/static/vincennes-2018/_custom.scss
index 8cc6398d..da3b725f 100644
--- a/static/vincennes-2018/_custom.scss
+++ b/static/vincennes-2018/_custom.scss
@@ -1,26 +1,29 @@
 @import '../includes/font-opensans';
 
 #header #top #logo {
-	padding-top: 10px;
+	padding-top: 20px;
 	padding-bottom: 10px;
-	a {
-		display: block;
-		background: url(img/logo_rouge_et_bleu.png) bottom right no-repeat;
-		background-size: 300px;
-		padding-top: 60px;
+	display: block;
+	a:first-child {
 		color: $primary-color;
 		text-transform: uppercase;
 		font-weight: normal;
 		font-size: 3rem;
 	}
+	a#link-to-city-site {
+		padding-top: 40px;
+		float: right;
+		background: url(img/logo_rouge_et_bleu.png) bottom right no-repeat;
+		width: 250px;
+		text-indent: -5000px;
+	}
 }
 
 @media screen and (max-width: $mobile-limit) {
 	#header #top #logo {
 		padding-left: 0;
-		a {
-			white-space: pre;
-			padding-bottom: 50px;
+		a#link-to-city-site {
+			padding-top: 20px;
 		}
 	}
 }
diff --git a/static/vincennes-2018/img/logo_rouge_et_bleu.png b/static/vincennes-2018/img/logo_rouge_et_bleu.png
index 371c661bf516c34581ea342a0fe7b2b0afa03e0e..1484e8d0bba58d4eda162e5efd9e479a434bc5ac 100644
GIT binary patch
diff --git a/templates/variants/vincennes-2018/theme.html b/templates/variants/vincennes-2018/theme.html
new file mode 100644
index 00000000..2254a22b
--- /dev/null
+++ b/templates/variants/vincennes-2018/theme.html
@@ -0,0 +1,5 @@
+{% extends '../../theme.html' %}
+
+{% block header-title %}
+  <h1 id="logo"><a accesskey="1" href="{% firstof logo_link_url portal_url '/' %}">{% firstof global_title site_title "Compte Citoyen" %}</a><a id="link-to-city-site" href="https://www.vincennes.fr/">vincennes.fr</a></h1>
+{% endblock %}
-- 
2.20.1