From 7a25eb27c1ba97f5fae6f3c33de7a89ab89a8da8 Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Mon, 14 Jan 2019 15:10:26 +0100
Subject: [PATCH] ville-tours: add initial theme (#29721)

---
 static/ville-tours/_custom.scss | 101 ++++++++++++++++++++++++++++++++
 static/ville-tours/_vars.scss   |  40 +++++++++++++
 static/ville-tours/config.json  |   6 ++
 static/ville-tours/img/logo.png | Bin 0 -> 4015 bytes
 static/ville-tours/style.scss   |   6 ++
 5 files changed, 153 insertions(+)
 create mode 100644 static/ville-tours/_custom.scss
 create mode 100644 static/ville-tours/_vars.scss
 create mode 100644 static/ville-tours/config.json
 create mode 100644 static/ville-tours/img/logo.png
 create mode 100644 static/ville-tours/style.scss

diff --git a/static/ville-tours/_custom.scss b/static/ville-tours/_custom.scss
new file mode 100644
index 00000000..54f3b642
--- /dev/null
+++ b/static/ville-tours/_custom.scss
@@ -0,0 +1,101 @@
+div#header-wrapper {
+	border-top: 32px solid #efe6dd;
+}
+
+div#header {
+	h1#logo {
+		a {
+			background: url('img/logo.png') no-repeat;
+			background-size: contain;
+			display: block;
+			height: 93px;
+			text-indent: -9999px;
+			margin: 15px 0;
+		}
+	}
+	#toplinks {
+		position: absolute;
+		top: -47px;
+	}
+}
+
+.gru-content {
+	div.searchcell {
+		border: 0;
+		form {
+			input {
+				border: 1px solid #cdac89;
+				background: #efe6dd;
+				padding: 3px;
+				width: 90%;
+				font-size: 1.12em;
+			}
+			button {
+				padding: 0.5ex 0.4em;
+			}
+		}
+		div.combo-search-results {
+			background: #efe6dd;
+			p.search-service-label {
+				padding: 0.5ex 0.5em;
+			}
+			a {
+				color: #7aa63e;
+			}
+		}
+	}
+	#columns > div.wcsformsofcategorycell {
+		h2:first-child {
+			font-family: 'SourceSansPro-Bold', sans-serif;
+			color: #000000;
+			font-size: 150%;
+			border-bottom: 0;
+			text-align: center;
+			padding-bottom: 0;
+		}
+		border: 0;
+		@media screen and (min-width: $mobile-limit) {
+			width: 23%;
+			float: left;
+			margin-bottom: 2ex;
+			margin-left: 0.5em;
+			margin-right: 0.5em;
+		}
+	}
+}
+
+div#nav a {
+	font-size: 1.25em;
+	&:hover {
+		color: $primary-color;
+	}
+}
+
+div#rub_service {
+	h2 {
+		text-align: left;
+	}
+	form > div.buttons {
+		div.submit-button {
+			float: right;
+		}
+	}
+}
+
+div#footer {
+	h2 {
+		color: $title-color;
+		margin: 0.5ex auto;
+	}
+	a {
+		color: #ffffff;
+	}
+	ul {
+		margin: 0;
+		padding: 0;
+		li {
+			list-style-type: none;
+			font-size: 95%;
+		}
+	}
+}
diff --git a/static/ville-tours/_vars.scss b/static/ville-tours/_vars.scss
new file mode 100644
index 00000000..33c3c94b
--- /dev/null
+++ b/static/ville-tours/_vars.scss
@@ -0,0 +1,40 @@
+$primary-color: #6699cc;
+$width: 1100px;
+
+$background-color: #ffffff;
+
+$font-color: black;
+$font-family: 'SourceSansPro-Regular', sans-serif;
+$font-size: 16px;
+
+$nav-color: #000000;
+$nav-submenu-color: #000000;
+$nav-active-color: $primary-color;
+$nav-item-selected-border: 5px solid $nav-active-color;
+$nav-item-hover-color: $primary-color;
+$nav-item-hover-mode: bottom-border;
+$nav-item-selected-mode: bottom-border;
+$nav-item-hover-color: $primary-color;
+$nav-after-image-height: 260px;
+
+$link-color: $primary-color;
+
+$cell-border: 1px solid $primary-color;
+
+$border-radius: 0px;
+
+$widget-background: #efe6dd;
+$widget-unique-checkbox-position: left;
+
+$button-color: white;
+$button-background: #7aa63e;
+$button-hover-background: $primary-color;
+
+$title-border-bottom: 2px solid $primary-color;
+$title-weight: normal;
+$title-color: $primary-color;
+$title-font-size: 1.5em;
+$title-weight: 600;
+
+$footer-background: #000000;
+$footer-color: white;
diff --git a/static/ville-tours/config.json b/static/ville-tours/config.json
new file mode 100644
index 00000000..3af4724e
--- /dev/null
+++ b/static/ville-tours/config.json
@@ -0,0 +1,6 @@
+{
+  "label": "Ville de Tours",
+  "variables": {
+    "theme_color": "#efe6dd"
+  }
+}
diff --git a/static/ville-tours/img/logo.png b/static/ville-tours/img/logo.png
new file mode 100644
index 0000000000000000000000000000000000000000..8e80713d6275f14ef063ee07fa6e449e5fc57f74
GIT binary patch
diff --git a/static/ville-tours/style.scss b/static/ville-tours/style.scss
new file mode 100644
index 00000000..03a38771
--- /dev/null
+++ b/static/ville-tours/style.scss
@@ -0,0 +1,6 @@
+@charset "UTF-8";
+
+@import 'vars';
+@import '../includes/publik';
+@import '../includes/font-source-sans-pro';
+@import 'custom';
-- 
2.20.1